function dfprogram(Init);
clc
tic
disp('Select wavefile');
dir *.wav %Search for Wav files
Input_File = input('File Name: ','s');
[Y,FS]=wavread(Input_File);
[O,P] = size(Y);
speaknum = input('Enter Number of Speakers (Even number of speakers, minimum 2): ');
if P == 1 %If is a single source, the programs asks for it's position
    Xm = input('Enter the Xm Position of the notional source on the Z0 axis: ');
end
rho = input('Enter Distance on the Z plane from Notional Source to speaker array: ');
sigma = input('Enter Distance on the Z plane from Speaker Array to Listener position: ');
deltaX = input('Enter Distance between Loudspeakers: ');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
delay = floor(squeeze(((rho) / 343) * FS));         %Time delay in samples from source to array
Xn = -1*(((speaknum/2-1)*deltaX) + (deltaX/2));     %Centers array at (0,0)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if P == 2   %Stereo Case
    CH1 = zeros(O+delay,1);                         %Creates vectors for keeping audio. 
    CH2 = zeros(O+delay,1);                         %Size audio length + delay
    CH1(1:O,1)=Y(:,1);
    CH2(1:O,1)=Y(:,2);
    clear Y                                         %For saving memory
    Xm = -1*tan((30*pi)/180) * (rho+sigma);         % Calculates Xm position for 
    disp('Stereo Source')                           %30 deg. to the listener axis
    disp('Processing')
    disp('Ch1')
    [Cwav] = drivingfunction(CH1,FS,Xm,Xn,rho,sigma,deltaX,speaknum);
    disp('Ch2')
    [Dwav] = drivingfunction(CH2,FS,(-1*Xm),Xn,rho,sigma,deltaX,speaknum);    
    [Cx Cy] = size(Cwav);
    stereo_signal = zeros(speaknum,Cy);             %Makes sumation of the 2 sources    
    stereo_signal = (Cwav + Dwav) .* .5;            %and reduces the output by .5 to avoid cliping 
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    stereo_signal_resized = zeros(speaknum,Cy-delay);
    [Cx_resized,Cy_resized] = size(stereo_signal_resized);    
    stereo_signal_resized = stereo_signal(:,delay:Cy);  %Removes delay from source to array
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    stereo_signal_resampled = resample(stereo_signal_resized',(48000/FS),1);
    stereo_signal_resampled = stereo_signal_resampled'; %Resamples files to 48000
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
    sound_file = zeros(Cy,2);    
    disp('Saving Files');
    stereo_files = 0;                               %Saves Output as stereo Channels.
       while stereo_files < speaknum
            sound_file(:,1) = stereo_signal_resampled(stereo_files+1,:)';
            sound_file(:,2) = stereo_signal_resampled(stereo_files+2,:)';
            File_name = ['Stereo_File_' int2str(stereo_files)];
            wavwrite(sound_file,FS,File_name)
            stereo_files = stereo_files + 2;
        end
        save Output_signals.mat stereo_signal_resampled P FS; %Saves output matrix as a *.mat file
else                            %Single source case
    CH1 = zeros((O+delay),1);   %Creates vectors for keeping audio. 
    CH1(1:O,1)=Y(:,1);          %Size audio length + delay
    clear Y                     %For saving memory
    disp('Single source');
    disp('Processing')
    [Cwav] = drivingfunction(CH1,FS,Xm,Xn,rho,sigma,deltaX,speaknum);
    [Cx,Cy] = size(Cwav);    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    Cwav_resized = zeros(speaknum,Cy-delay);
    [Cx_resized,Cy_resized] = size(Cwav_resized);    
    Cwav_resized = Cwav(:,delay:Cy);    %Removes delay from source to array
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    Cwav_resampled = resample(Cwav_resized',(48000/FS),1);
    Cwav_resampled = Cwav_resampled';   %Resamples files to 48000
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    disp('Saving Files');    
    sound_file = zeros(Cy,2);
    stereo_files = 0;                   %Saves Output as stereo Channels.
            while stereo_files < speaknum                
                sound_file(:,1) = Cwav(stereo_files+1,:)';
                sound_file(:,2) = Cwav(stereo_files+2,:)';
                File_name = ['Mono_File_' int2str(stereo_files)];
                wavwrite(sound_file,FS,File_name)
                stereo_files = stereo_files + 2;
            end          
            save Output_signals.mat Cwav_resampled delay P FS; %Saves output matrix as a *.mat file
end
disp('Finished');
t = toc;
disp(sprintf('%f Seconds ',t ))
clear all