function [Cwav] = drivingfunction(Y,FS,Xm,Xn,rho,sigma,deltaX,Num_of_Speakers);
load gdata27;
Z1 = 0;         %Array plane position (Xn,Z1)
Z0 = Z1 - rho;  %Source plane position (Xm,Z1)
c = 343;        %Speed of sound [m/s]
%%%%%%%%%%%%%%%%%%%%%%%
%%Freq Transformation%%
%%%%%%%%%%%%%%%%%%%%%%%
[B,F,T] = SPECGRAM(Y,FS,FS,256,128);
Wav_length = length(Y);
clear Y         %For saving memory
[Bx By] = size(B);
Cs = zeros(Num_of_Speakers,Bx,By);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for speakers = 1:1:Num_of_Speakers      %Loop for calculating driving function for each speaker.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
theta = atan2((Xn-Xm),(Z1-Z0))          %Calculates theta for the speaker number (Num_of_Speakers)
Xn
R = sqrt(((Xn-Xm)^2) + ((Z1-Z0)^2));    %|rn-rm|
T3 = sqrt((sigma)/(sigma+rho));         %Part of the driving function
for counter2=1:1:length(T)              %Counter for Time position
    for counter = 1:1:length(F)         %Counter for Frequency position         
        semiQ = (exp (-j * ( ( F(counter,1) *2*pi ) /c )* R ) ) /(sqrt(R)); %Part of the driving function
        T2 = sqrt((j*((F(counter,1)*2*pi)/c))/(2*pi));                      %Part of the driving function
        if F(counter,1) > 19500         %Makes freq. gain = g(19500) if higer than 19500 Hz.
           F(counter,1) = 19500;
        end
        if F(counter,1) < 30            %Makes freq. gain=1 if lower than 30Hz.
            FreqGain = 1;
            else
            FreqGain = G(gdata27,(theta),(F(counter,1)));       %Gain calculation for specific frequency
        end
        T1 = cos(theta)/FreqGain;        
        Cs(speakers,counter,counter2)= B(counter,counter2) .* semiQ .* T1 .* T2 .* T3; %Driving function   
    end
end
Xn = Xn + deltaX;                       %Updates Xn to calculate the next speaker information
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear B         %For Saving memory
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%Frequency domain to time transformation%%
%%           Wave File Creation          %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for speakers = 1:1:Num_of_Speakers      %saves the channels into a matrix called Cwav
    spectrum(:,:) = Cs(speakers,:,:);
    Cwav(speakers,:,:) = squeeze(invspecgram(spectrum,FS,FS,256,128));
end
clear Cs