clear all;
close all;
clc;

load fish27data;
fish = ir;        % Selected loudspeaker to analyse

samplefrequency = 48000;
cutofffrequency = 20000; % Maximum frequency in FFT plots
wanted_ir_length = 1600;
impulse_response = zeros(wanted_ir_length,1);
impulse_response_fft_length = ceil((cutofffrequency / samplefrequency) * wanted_ir_length);
g27_data = zeros(size(fish,1) , impulse_response_fft_length);

ir27=zeros(size(fish,1),wanted_ir_length);

for i = 1 : size(fish,1)
    impulse_response = fish(i , 133 : 132 + wanted_ir_length);                      % Fjern de frste 132 samples, fr impulsen starter
    ir27(i,:) = impulse_response;
    impulse_response_fft = abs(fft(impulse_response));                                  % Lav FFT af impulsrespons og find amplituden
    impulse_response_fft_part = impulse_response_fft(1 : impulse_response_fft_length);           % Limit frequency range
    filter_width = 15;
    filtered_impulse_response_fft=impulse_response_fft_part;
    for j = 1+floor(filter_width/2) : length(filtered_impulse_response_fft)-floor(filter_width/2)
        filtered_impulse_response_fft(j) = mean(impulse_response_fft_part(j - floor(filter_width / 2) : j + floor(filter_width/2)));
    end
    g27_data(i,:)=filtered_impulse_response_fft;
    g27_data(i,:)=impulse_response_fft_part;
end

plot_frequency = 12000;  % Make directivity-plot for a 1 kHz tone
selected_bin_no = round(impulse_response_fft_length * plot_frequency / cutofffrequency);

j=1;
for i=0:2.5:180
    angle(j)=2*pi*i/360;
    j=j+1;
end
polar([-angle(end:-1:1) angle] , [g27_data(end:-1:1,selected_bin_no) ; g27_data(:,selected_bin_no)]' )

%mlsvec_fft_x=[0 : samplefrequency/(2*(length(impulse_response_fft_part)-1)) : samplefrequency/2];                  % Beregn vrdier til x-akse p frekvensplot
%semilogx(mlsvec_fft_x , 20*log(mlsvec_fft)-20*log(mean(mlsvec_fft(mean_lowerlimit:mean_upperlimit))));                                 % Lav frekvensplot med logaritmisk skala p x-aksen og omregnet til dB SPL p y-aksen


%semilogx(mlsvec_fft_x , 20*log(filtered_mlsvec_fft))

%xlabel('Frequency [Hz]');
%ylabel('Amplitude [dB]');
TITLE(strcat('Loudspeaker fish27 directivity @',num2str(plot_frequency),'Hz'));

%ylim([-90 10])
%xlim([0 20000])
