function [output] = plot_frq_resp(signal,sample_frequency,frequency_0db)
% Usage: plot_frq_resp(signal,sample_frequency,frequency_0db)

x = [0 : sample_frequency / length(signal) : sample_frequency / 2 - sample_frequency / length(signal)];
fft_signal = abs(fft(signal));
align_bin = round(length(signal) * frequency_0db / sample_frequency);

fft_signal = fft_signal / fft_signal(align_bin);

semilogx(x, 20 * log(fft_signal(1 : length(x))))
xlabel('Frequency [Hz]')
ylabel(strcat('Amplitude normalized at ',num2str(frequency_0db),' Hz'))