function [window]=createwindow(speakers);
%
% Returns a weighting vector for an array of loudspeakers.
% The left and right 1/3 of the array is weighted with a cosine function,
% and the middle 1/3 is ones.
%
% Usage: window=createwindow(no_speakers);

window_hanning=hanning(ceil(speakers/3)*2)';
window=[window_hanning(1:ceil(length(window_hanning)/2)) ones(1,speakers-length(window_hanning)) window_hanning(ceil(length(window_hanning)/2+1):ceil(length(window_hanning)))];
